From a1629fad7aa8113657039d62f16ee60ef3c5aa59 Mon Sep 17 00:00:00 2001
From: Thomas JUND <tjund@entrouvert.com>
Date: Fri, 18 Oct 2019 17:11:43 +0200
Subject: [PATCH] SCSS: All custom themes: header is now .site-header (#36765)

---
 static/bouches-du-rhone/_custom.scss           |  2 +-
 static/calvados-cd14/_custom.scss              |  8 ++++----
 static/castries/_custom.scss                   |  2 +-
 static/cnil/_custom.scss                       |  2 +-
 static/cotes-d-armor/_custom.scss              |  2 +-
 static/grosboule-les-bains/_custom.scss        |  4 ++--
 static/lille-metropole/_custom.scss            |  4 ++--
 static/lille/_custom.scss                      |  2 +-
 static/lot-cd46/_custom.scss                   | 10 +++++-----
 static/metz-metropole-2019/_custom.scss        |  2 +-
 static/mincult/_custom.scss                    |  2 +-
 static/moselle/_custom.scss                    |  8 ++++----
 static/murviel-les-montpellier/_custom.scss    |  2 +-
 static/perpette-les-andouillettes/_custom.scss |  2 +-
 static/pfwb/_custom.scss                       |  6 +++---
 static/pre-saint-gervais/_custom.scss          |  2 +-
 static/roannais-agglomeration/_custom.scss     |  2 +-
 static/saint-chamond/_custom.scss              |  2 +-
 static/toodego/_custom.scss                    |  4 ++--
 static/toulouse/_custom.scss                   |  4 ++--
 20 files changed, 36 insertions(+), 36 deletions(-)

diff --git a/static/bouches-du-rhone/_custom.scss b/static/bouches-du-rhone/_custom.scss
index c722ec6c..3a28af22 100644
--- a/static/bouches-du-rhone/_custom.scss
+++ b/static/bouches-du-rhone/_custom.scss
@@ -1,5 +1,5 @@
 
-header {
+.site-header {
 	position: absolute;
 	left: 15%;
 	top: 2rem;
diff --git a/static/calvados-cd14/_custom.scss b/static/calvados-cd14/_custom.scss
index 179569b8..743052bf 100644
--- a/static/calvados-cd14/_custom.scss
+++ b/static/calvados-cd14/_custom.scss
@@ -28,7 +28,7 @@ a#publik-portal-agent {
 	}
 }
 
-header {
+.site-header {
 	position: fixed;
 	top: 0;
 	left: 0;
@@ -132,7 +132,7 @@ body.has-picture {
 }
 
 body.scrolled {
-	header #header,
+	.site-header #header,
 	div#nav > ul {
 		margin-top: 0;
 		margin-bottom: 0;
@@ -170,7 +170,7 @@ span.helptext, div.hint {
 }
 
 @media screen and (max-width: $mobile-limit) {
-	div#nav, header {
+	div#nav, .site-header {
 		text-align: left;
 		position: static;
 		width: auto;
@@ -181,7 +181,7 @@ span.helptext, div.hint {
 		}
 	}
 
-	header #header {
+	.site-header #header {
 		margin-top: 2rem;
 		margin-bottom: 1rem;
 	}
diff --git a/static/castries/_custom.scss b/static/castries/_custom.scss
index fb9d0eb6..56f5d58e 100644
--- a/static/castries/_custom.scss
+++ b/static/castries/_custom.scss
@@ -14,7 +14,7 @@ div#page {
 	margin: 0 auto;
 	box-shadow: 0 0px 2px rgba(0, 0, 0, 0.27);
 	border-radius: 2 * $border-radius;
-	header, nav, #main-content-wrapper {
+	.site-header, nav, #main-content-wrapper {
 		box-sizing: border-box;
 		padding: 0 20px;
 		@media screen and (max-width: $mobile-limit) {
diff --git a/static/cnil/_custom.scss b/static/cnil/_custom.scss
index a0211f40..908f997f 100644
--- a/static/cnil/_custom.scss
+++ b/static/cnil/_custom.scss
@@ -8,7 +8,7 @@ body {
 	}
 }
 
-header {
+.site-header {
 	background: white;
 	border-top: 40px solid #444444;
 	@media screen and (max-width: $mobile-limit) {
diff --git a/static/cotes-d-armor/_custom.scss b/static/cotes-d-armor/_custom.scss
index ff18244a..2ca86a5e 100644
--- a/static/cotes-d-armor/_custom.scss
+++ b/static/cotes-d-armor/_custom.scss
@@ -1,4 +1,4 @@
-header {
+.site-header {
 	background: $primary-color;
 	background: linear-gradient(to bottom, darken($primary-color, 20%) 0%, $primary-color 100%);
 }
diff --git a/static/grosboule-les-bains/_custom.scss b/static/grosboule-les-bains/_custom.scss
index 76520bee..de80fdec 100644
--- a/static/grosboule-les-bains/_custom.scss
+++ b/static/grosboule-les-bains/_custom.scss
@@ -1,5 +1,5 @@
 body.has-header-background {
-	header {
+	.site-header {
 		background: none;
 		padding-bottom: 0;
 	}
@@ -26,7 +26,7 @@ h1#logo.has-logo a {
 	font-size: 90%;
 }
 
-header {
+.site-header {
 	position: fixed;
 	top: 0;
 	left: 0;
diff --git a/static/lille-metropole/_custom.scss b/static/lille-metropole/_custom.scss
index 4d6904eb..c25116a2 100644
--- a/static/lille-metropole/_custom.scss
+++ b/static/lille-metropole/_custom.scss
@@ -46,7 +46,7 @@ div#page {
 	}
 }
 
-header {
+.site-header {
 	position: fixed;
 	top: 0;
 	left: 0;
@@ -114,7 +114,7 @@ body.has-picture nav::after {
 }
 
 @media screen and (max-width: $mobile-limit) {
-	div#nav, header {
+	div#nav, .site-header {
 		text-align: left;
 		position: static;
 		width: auto;
diff --git a/static/lille/_custom.scss b/static/lille/_custom.scss
index 4267a4c5..10650951 100644
--- a/static/lille/_custom.scss
+++ b/static/lille/_custom.scss
@@ -19,7 +19,7 @@ $form-picto-keywords: adresse, aquabike, archives, asso, attestation, bibliotheq
 	}
 }
 
-header {
+.site-header {
 	z-index: 200;
 	background: white;
 }
diff --git a/static/lot-cd46/_custom.scss b/static/lot-cd46/_custom.scss
index 0c6000a0..36c5bc22 100644
--- a/static/lot-cd46/_custom.scss
+++ b/static/lot-cd46/_custom.scss
@@ -10,7 +10,7 @@
 	font-size: 90%;
 }
 
-header {
+.site-header {
 	position: fixed;
 	top: 0;
 	left: 0;
@@ -82,12 +82,12 @@ body.scrolled {
 	#toplinks {
 		top: -2rem;
 	}
-	header #header,
+	.site-header #header,
 	div#nav > ul {
 		margin-top: 0;
 		margin-bottom: 0;
 	}
-	header #header h1 a {
+	.site-header #header h1 a {
 		height: 40px;
 		line-height: 40px;
 		background-position: 10px center;
@@ -101,7 +101,7 @@ body.scrolled {
 }
 
 @media screen and (max-width: $mobile-limit) {
-	div#nav, header {
+	div#nav, .site-header {
 		background: $darkpink;
 		text-align: left;
 		position: static;
@@ -120,7 +120,7 @@ body.scrolled {
 		margin-top: -68px;
 	}
 
-	header #header,
+	.site-header #header,
 	div#nav > ul {
 		margin-top: 2rem;
 		margin-bottom: 1rem;
diff --git a/static/metz-metropole-2019/_custom.scss b/static/metz-metropole-2019/_custom.scss
index cd5b627f..cd79dd2a 100644
--- a/static/metz-metropole-2019/_custom.scss
+++ b/static/metz-metropole-2019/_custom.scss
@@ -13,7 +13,7 @@ button::-moz-focus-inner {
 	border: 0;
 }
 
-header {
+.site-header {
 	z-index: 200;
 	height: $header-height;
 	background: white;
diff --git a/static/mincult/_custom.scss b/static/mincult/_custom.scss
index d810f13e..58574bcd 100644
--- a/static/mincult/_custom.scss
+++ b/static/mincult/_custom.scss
@@ -1,6 +1,6 @@
 @import '../includes/font-titillium';
 
-header {
+.site-header {
 	background: $primary-color;
 }
 
diff --git a/static/moselle/_custom.scss b/static/moselle/_custom.scss
index f5b37a38..c5bced2f 100644
--- a/static/moselle/_custom.scss
+++ b/static/moselle/_custom.scss
@@ -4,7 +4,7 @@
 	box-shadow: none;
 }
 
-header {
+.site-header {
 	background: $primary-color;
 	position: fixed;
 	top: 0;
@@ -78,7 +78,7 @@ body.has-picture {
 }
 
 body.scrolled {
-	header #header {
+	.site-header #header {
 		margin: 0;
 	}
 	div#nav > ul {
@@ -101,7 +101,7 @@ footer {
 	#page {
 		background: transparent;
 	}
-	div#nav, header {
+	div#nav, .site-header {
 		text-align: left;
 		position: static;
 		width: auto;
@@ -112,7 +112,7 @@ footer {
 		}
 	}
 
-	header #header,
+	.site-header #header,
 	div#nav > ul {
 		margin-top: 2rem;
 		margin-bottom: 1rem;
diff --git a/static/murviel-les-montpellier/_custom.scss b/static/murviel-les-montpellier/_custom.scss
index c5f4598b..a9136e04 100644
--- a/static/murviel-les-montpellier/_custom.scss
+++ b/static/murviel-les-montpellier/_custom.scss
@@ -14,7 +14,7 @@ div#page {
 	max-width: $width;
 	margin: 0 auto;
 	box-shadow: 0 0px 2px rgba(0, 0, 0, 0.27);
-	header, nav, #main-content-wrapper {
+	.site-header, nav, #main-content-wrapper {
 		box-sizing: border-box;
 		padding: 0 20px;
 		@media screen and (max-width: $mobile-limit) {
diff --git a/static/perpette-les-andouillettes/_custom.scss b/static/perpette-les-andouillettes/_custom.scss
index 97a89c5b..e663eec1 100644
--- a/static/perpette-les-andouillettes/_custom.scss
+++ b/static/perpette-les-andouillettes/_custom.scss
@@ -1,5 +1,5 @@
 body.has-header-background {
-	header {
+	.site-header {
 		height: 150px;
 		padding-bottom: 10px;
 		h1#logo {
diff --git a/static/pfwb/_custom.scss b/static/pfwb/_custom.scss
index 015096a9..11086323 100644
--- a/static/pfwb/_custom.scss
+++ b/static/pfwb/_custom.scss
@@ -12,7 +12,7 @@ span#environment-label {
 	font-size: 10px;
 }
 
-header {
+.site-header {
 	#header {
 		padding: 0;
 		transition: all ease 0.2s;
@@ -122,7 +122,7 @@ body.has-picture {
 }
 
 @media screen and (max-width: $mobile-limit) {
-	div#nav, header {
+	div#nav, .site-header {
 		text-align: left;
 		position: static;
 		width: auto;
@@ -138,7 +138,7 @@ body.has-picture {
 		}
 	}
 
-	header #header {
+	.site-header #header {
 		margin-top: 3rem;
 		margin-bottom: 0.4rem;
 	}
diff --git a/static/pre-saint-gervais/_custom.scss b/static/pre-saint-gervais/_custom.scss
index 308038b4..d11629e2 100644
--- a/static/pre-saint-gervais/_custom.scss
+++ b/static/pre-saint-gervais/_custom.scss
@@ -79,7 +79,7 @@ body {
 	line-height: 1.5;
 }
 
-header {
+.site-header {
 	position: fixed;
 	z-index: 1000;
 	width: 100%;
diff --git a/static/roannais-agglomeration/_custom.scss b/static/roannais-agglomeration/_custom.scss
index f168acb2..4a93aa93 100644
--- a/static/roannais-agglomeration/_custom.scss
+++ b/static/roannais-agglomeration/_custom.scss
@@ -2,7 +2,7 @@ body {
 	font-weight: 300;
 }
 
-header {
+.site-header {
 	pointer-events: none;
 	background: $red;
 	padding-top: 0;
diff --git a/static/saint-chamond/_custom.scss b/static/saint-chamond/_custom.scss
index 76009a3a..a164dab0 100644
--- a/static/saint-chamond/_custom.scss
+++ b/static/saint-chamond/_custom.scss
@@ -1,6 +1,6 @@
 $dashboard-slugs: accueil, mon-compte, mes-demandes, mon-association, mon-commerce, mon-porte-doc;
 
-header {
+.site-header {
 	background: $blue;
 	padding-top: 25px;
 	padding-bottom: 40px;
diff --git a/static/toodego/_custom.scss b/static/toodego/_custom.scss
index 977d061f..09a3094a 100644
--- a/static/toodego/_custom.scss
+++ b/static/toodego/_custom.scss
@@ -16,11 +16,11 @@ body {
 	}
 }
 
-header {
+.site-header {
 	z-index: 1000;
 }
 
-header, nav {
+.site-header, nav {
 	background: white;
 }
 
diff --git a/static/toulouse/_custom.scss b/static/toulouse/_custom.scss
index 4f94663f..726b75b9 100644
--- a/static/toulouse/_custom.scss
+++ b/static/toulouse/_custom.scss
@@ -46,7 +46,7 @@ a:hover {
 	}
 }
 
-header {
+.site-header {
 	position: fixed;
 	top: 0;
 	left: 0;
@@ -1742,7 +1742,7 @@ div#rub_service div#info {
 }
 
 .authentic-page {
-	header, nav, div#actu {
+	.site-header, nav, div#actu {
 		display: none;
 	}
 	div#page {
-- 
2.20.1